diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/model/warnings.h ns-3.38/src/core/model/warnings.h
--- ns-3.37/src/core/model/warnings.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/core/model/warnings.h	2023-03-16 20:54:23.596868500 -0700
@@ -0,0 +1,86 @@
+/*
+ * Copyright (c) 2022 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#ifndef NS3_WARNINGS_H
+#define NS3_WARNINGS_H
+
+/**
+ * \ingroup core
+ * \def NS_WARNING_POP
+ * Pops the diagnostic warning list from the stack, restoring it to the previous state.
+ * \sa NS_WARNING_PUSH
+ */
+
+/**
+ * \ingroup core
+ * \def NS_WARNING_PUSH
+ * Push the diagnostic warning list to the stack, allowing it to be restored later.
+ * \sa NS_WARNING_POP
+ */
+
+/**
+ * \ingroup core
+ * \def NS_WARNING_SILENCE_DEPRECATED
+ * Silences the "-Wdeprecated-declarations" warnings.
+ * \sa NS_WARNING_POP
+ */
+
+/**
+ * \ingroup core
+ * \def NS_WARNING_PUSH_DEPRECATED
+ * Save the current warning list and disables the ones about deprecated functions and classes.
+ *
+ * This macro can be used to silence deprecation warnings and should be used as a last resort
+ * to silence the compiler for very specific lines of code.
+ * The typical pattern is:
+ * \code
+ *   NS_WARNING_PUSH_DEPRECATED;
+ *   // call to a function or class that has been deprecated.
+ *   NS_WARNING_POP;
+ * \endcode
+ *
+ * Its use is, of course, not suggested unless strictly necessary.
+ */
+
+#if defined(_MSC_VER)
+// You can find the MSC warning codes at
+// https://learn.microsoft.com/en-us/cpp/error-messages/compiler-warnings/compiler-warnings-c4000-c5999
+#define NS_WARNING_PUSH __pragma(warning(push))
+#define NS_WARNING_SILENCE_DEPRECATED __pragma(warning(disable : 4996))
+#define NS_WARNING_POP __pragma(warning(pop))
+
+#elif defined(__GNUC__) || defined(__clang__)
+// Clang seems to understand these GCC pragmas
+#define NS_WARNING_PUSH _Pragma("GCC diagnostic push")
+#define NS_WARNING_SILENCE_DEPRECATED                                                              \
+    _Pragma("GCC diagnostic ignored \"-Wdeprecated-declarations\"")
+#define NS_WARNING_POP _Pragma("GCC diagnostic pop")
+
+#else
+#define NS_WARNING_PUSH
+#define NS_WARNING_SILENCE_DEPRECATED
+#define NS_WARNING_POP
+
+#endif
+
+#define NS_WARNING_PUSH_DEPRECATED                                                                 \
+    NS_WARNING_PUSH;                                                                               \
+    NS_WARNING_SILENCE_DEPRECATED
+
+#endif /* NS3_WARNINGS_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/attribute-test-suite.cc ns-3.38/src/core/test/attribute-test-suite.cc
--- ns-3.37/src/core/test/attribute-test-suite.cc	2022-11-01 17:37:24.475395000 -0700
+++ ns-3.38/src/core/test/attribute-test-suite.cc	2023-03-16 20:54:23.596868500 -0700
@@ -265,7 +265,7 @@
                               MakeBooleanChecker())
                 .AddAttribute("EnumTraceSource",
                               "help text",
-                              EnumValue(false),
+                              EnumValue(TEST_A),
                               MakeEnumAccessor(&AttributeObjectTest::m_enumSrc),
                               MakeEnumChecker(TEST_A, "TestA"))
                 .AddAttribute("ValueClassSource",
@@ -495,7 +495,7 @@
     Ptr<Derived> m_ptrInitialized;           //!< Pointer to Derived class.
     Ptr<Derived> m_ptrInitialized2;          //!< Pointer to Derived class.
     TracedValue<uint8_t> m_uintSrc;          //!< uint8_t Traced value.
-    TracedValue<enum Test_e> m_enumSrc;      //!< enum Traced value.
+    TracedValue<Test_e> m_enumSrc;           //!< enum Traced value.
     TracedValue<double> m_doubleSrc;         //!< double Traced value.
     TracedValue<bool> m_boolSrc;             //!< bool Traced value.
     Time m_timeWithBounds;                   //!< Time with bounds
@@ -908,16 +908,16 @@
     // When the object is first created, the Attribute should have the default
     // value.
     //
-    ok = CheckGetCodePaths(p, "TestFloat", "-1.1", DoubleValue((float)-1.1));
+    ok = CheckGetCodePaths(p, "TestFloat", "-1.1", DoubleValue(-1.1F));
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Attribute not set properly by default value");
 
     //
     // Set the Attribute.
     //
-    ok = p->SetAttributeFailSafe("TestFloat", DoubleValue((float)2.3));
+    ok = p->SetAttributeFailSafe("TestFloat", DoubleValue(2.3F));
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Could not SetAttributeFailSafe() to 2.3");
 
-    ok = CheckGetCodePaths(p, "TestFloat", "2.3", DoubleValue((float)2.3));
+    ok = CheckGetCodePaths(p, "TestFloat", "2.3", DoubleValue(2.3F));
     NS_TEST_ASSERT_MSG_EQ(ok,
                           true,
                           "Attribute not set properly by SetAttributeFailSafe() via DoubleValue");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/callback-test-suite.cc ns-3.38/src/core/test/callback-test-suite.cc
--- ns-3.37/src/core/test/callback-test-suite.cc	2022-11-01 17:37:24.475395000 -0700
+++ ns-3.38/src/core/test/callback-test-suite.cc	2023-03-16 20:54:23.596868500 -0700
@@ -97,7 +97,7 @@
 };
 
 /**
- * Variable to verify that a calback has been called.
+ * Variable to verify that a callback has been called.
  * @{
  */
 static bool gBasicCallbackTest5;
@@ -138,7 +138,7 @@
 }
 
 BasicCallbackTestCase::BasicCallbackTestCase()
-    : TestCase("Check basic Callback mechansim")
+    : TestCase("Check basic Callback mechanism")
 {
 }
 
@@ -294,7 +294,7 @@
 };
 
 /**
- * Variable to verify that a calback has been called.
+ * Variable to verify that a callback has been called.
  * @{
  */
 static bool gMakeCallbackTest5;
@@ -449,7 +449,7 @@
 };
 
 /**
- * Variable to verify that a calback has been called.
+ * Variable to verify that a callback has been called.
  * @{
  */
 static int gMakeBoundCallbackTest1;
@@ -913,16 +913,16 @@
     // Make sure that a callback pointing to a lambda and a copy of it compare equal,
     // after binding the first argument.
     //
-    Callback<double, int> target8b = target7b.Bind(1);
-    Callback<double, int> target8c(target7c, 1);
+    Callback<double, double> target8b = target7b.Bind(1);
+    Callback<double, double> target8c(target7c, 1);
     NS_TEST_ASSERT_MSG_EQ(target8b.IsEqual(target8c), true, "Equality test failed");
 
     //
     // Make sure that a callback pointing to a lambda and a copy of it compare equal,
     // after binding the first two arguments.
     //
-    Callback<double> target9b = target8b.Bind(2);
-    Callback<double> target9c(target8c, 2);
+    Callback<double> target9b = target8b.Bind(2.0);
+    Callback<double> target9c(target8c, 2.0);
     NS_TEST_ASSERT_MSG_EQ(target9b.IsEqual(target9c), true, "Equality test failed");
 
     //
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/environment-variable-test-suite.cc ns-3.38/src/core/test/environment-variable-test-suite.cc
--- ns-3.37/src/core/test/environment-variable-test-suite.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/core/test/environment-variable-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
@@ -0,0 +1,339 @@
+/*
+ * Copyright (c) 2022 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+#include "ns3/environment-variable.h"
+#include "ns3/test.h"
+
+#include <cstdlib> // getenv
+
+namespace ns3
+{
+
+namespace tests
+{
+
+/**
+ * \file
+ * \ingroup environ-var-tests
+ * Environment variable caching test suite
+ */
+
+/**
+ * \ingroup core-tests
+ * \defgroup environ-var-tests Environment variable caching tests
+ */
+
+/**
+ * \ingroup environ-var-tests
+ *
+ * EnvironmentVariable tests
+ */
+class EnvVarTestCase : public TestCase
+{
+  public:
+    /** Constructor */
+    EnvVarTestCase();
+
+    /** Destructor */
+    ~EnvVarTestCase() override;
+
+  private:
+    /** Run the tests */
+    void DoRun() override;
+
+    /** The key,value store */
+    using KeyValueStore = EnvironmentVariable::Dictionary::KeyValueStore;
+
+    /** The return type from EnvironmentVariable::Get() */
+    using KeyFoundType = EnvironmentVariable::KeyFoundType;
+
+    /**
+     * Set the test environment variable.
+     * \param where The test condition being checked.
+     * \param value The value to set.
+     */
+    void SetVariable(const std::string& where, const std::string& value);
+
+    /**
+     * Unset the test environment variable.
+     * \param where The test condition being checked.
+     */
+    void UnsetVariable(const std::string& where);
+
+    /**
+     * Read \p envValue and check that it contains only the key,value pairs
+     * from \p expect.
+     * \param where The test condition being checked.
+     * \param envValue The environment variable to parse and check.
+     * \param expect The set of key,values expected.
+     */
+    void Check(const std::string& where, const std::string& envValue, KeyValueStore expect);
+
+    /**
+     * Set and Check the variable.
+     * \param where The test condition being checked.
+     * \param envValue The environment variable to parse and check.
+     * \param expect The set of key,values expected.
+     */
+    void SetAndCheck(const std::string& where, const std::string& envValue, KeyValueStore expect);
+
+    /**
+     * Check the result from a Get.
+     * \param where The test condition being checked.
+     * \param key The key to check.
+     * \param expect The expected result.
+     */
+    void CheckGet(const std::string& where, const std::string& key, KeyFoundType expect);
+
+    /**
+     * Set, Check, and Get a variable.
+     * \param where The test condition being checked.
+     * \param envValue The environment variable to parse and check.
+     * \param expectDict The set of key,values expected.
+     * \param key The key to check.
+     * \param expectValue The expected result.
+     */
+    void SetCheckAndGet(const std::string& where,
+                        const std::string& envValue,
+                        KeyValueStore expectDict,
+                        const std::string& key,
+                        KeyFoundType expectValue);
+
+    /** Always use a non-default delimiter. */
+    const std::string m_delimiter{"|"};
+
+    /** Test environment variable name. */
+    const std::string m_variable{"NS_ENVVAR_TEST"};
+
+}; // class EnvVarTestCase
+
+EnvVarTestCase::EnvVarTestCase()
+    : TestCase("environment-variable-cache")
+{
+}
+
+EnvVarTestCase::~EnvVarTestCase()
+{
+    UnsetVariable("destructor");
+}
+
+void
+EnvVarTestCase::SetVariable(const std::string& where, const std::string& value)
+{
+    EnvironmentVariable::Clear();
+    bool ok = EnvironmentVariable::Set(m_variable, value);
+    NS_TEST_EXPECT_MSG_EQ(ok, true, where << ": failed to set variable");
+
+    // Double check
+    const char* envCstr = std::getenv(m_variable.c_str());
+    NS_TEST_EXPECT_MSG_NE(envCstr, nullptr, where << ": failed to retrieve variable just set");
+    NS_TEST_EXPECT_MSG_EQ(envCstr, value, where << ": failed to retrieve value just set");
+}
+
+void
+EnvVarTestCase::UnsetVariable(const std::string& where)
+{
+    EnvironmentVariable::Clear();
+    bool ok = EnvironmentVariable::Unset(where);
+    NS_TEST_EXPECT_MSG_EQ(ok, true, where << ": failed to unset variable");
+}
+
+void
+EnvVarTestCase::Check(const std::string& where, const std::string& envValue, KeyValueStore expect)
+{
+    auto dict = EnvironmentVariable::GetDictionary(m_variable, m_delimiter)->GetStore();
+
+    // Print the expect and which ones were found in dict
+    std::cout << "\n"
+              << where << " variable: '" << envValue << "', expect[" << expect.size() << "]"
+              << ", dict[" << dict.size() << "]\n";
+
+    NS_TEST_EXPECT_MSG_EQ(dict.size(), expect.size(), where << ": unequal dictionary sizes");
+
+    std::size_t i{0};
+    for (const auto& kv : expect)
+    {
+        std::cout << "    [" << i++ << "] '" << kv.first << "'\t'" << kv.second << "'";
+
+        auto loc = dict.find(kv.first);
+        bool found = loc != dict.end();
+        std::cout << (found ? "\tfound" : "\tNOT FOUND");
+        NS_TEST_EXPECT_MSG_EQ(found, true, where << ": expected key not found: " << kv.second);
+
+        if (found)
+        {
+            bool match = kv.second == loc->second;
+            if (match)
+            {
+                std::cout << ", match";
+            }
+            else
+            {
+                std::cout << ", NO MATCH: '" << loc->second << "'";
+            }
+            NS_TEST_EXPECT_MSG_EQ(kv.second, loc->second, where << ": key found, value mismatch");
+        }
+        std::cout << "\n";
+        ++i;
+    }
+
+    // Now just check dict for unexpected values
+    i = 0;
+    bool first{true};
+    for (const auto& kv : dict)
+    {
+        bool found = expect.find(kv.first) != expect.end();
+        if (!found)
+        {
+            std::cout << (first ? "Unexpected keys:" : "");
+            first = false;
+            std::cout << "    [" << i << "] '" << kv.first << "'\t'" << kv.second << "'"
+                      << " unexpected key, value\n";
+        }
+        ++i;
+    }
+}
+
+void
+EnvVarTestCase::SetAndCheck(const std::string& where,
+                            const std::string& envValue,
+                            KeyValueStore expect)
+{
+    SetVariable(where, envValue);
+    Check(where, envValue, expect);
+}
+
+void
+EnvVarTestCase::CheckGet(const std::string& where, const std::string& key, KeyFoundType expect)
+{
+    auto [found, value] = EnvironmentVariable::Get(m_variable, key, m_delimiter);
+    NS_TEST_EXPECT_MSG_EQ(found,
+                          expect.first,
+                          where << ": key '" << key << "' " << (expect.first ? "not " : "")
+                                << "found unexpectedly");
+    NS_TEST_EXPECT_MSG_EQ(value,
+                          expect.second,
+                          where << ": incorrect value for key '" << key << "'");
+}
+
+void
+EnvVarTestCase::SetCheckAndGet(const std::string& where,
+                               const std::string& envValue,
+                               KeyValueStore expectDict,
+                               const std::string& key,
+                               KeyFoundType expectValue)
+{
+    SetAndCheck(where, envValue, expectDict);
+    CheckGet(where, key, expectValue);
+}
+
+void
+EnvVarTestCase::DoRun()
+{
+    // Environment variable not set.
+    UnsetVariable("unset");
+    Check("unset", "", {});
+    auto [found, value] = EnvironmentVariable::Get(m_variable);
+    NS_TEST_EXPECT_MSG_EQ(found, false, "unset: variable found when not set");
+    NS_TEST_EXPECT_MSG_EQ(value.empty(), true, "unset: non-empty value from unset variable");
+
+    // Variable set but empty
+#ifndef __WIN32__
+    // Windows doesn't support environment variables with empty values
+    SetCheckAndGet("empty", "", {}, "", {true, ""});
+#endif
+
+    // Key not in variable
+    SetCheckAndGet("no-key",
+                   "not|the|right=value",
+                   {{"not", ""}, {"the", ""}, {"right", "value"}},
+                   "key",
+                   {false, ""});
+
+    // Key only (no delimiter):  "key"
+    SetCheckAndGet("key-only", "key", {{"key", ""}}, "key", {true, ""});
+
+    // Extra delimiter: ":key",  "key:"
+    SetCheckAndGet("front-|", "|key", {{"key", ""}}, "key", {true, ""});
+    SetCheckAndGet("back-|", "key|", {{"key", ""}}, "key", {true, ""});
+
+    // Double delimiter: "||key", "key||"
+    SetCheckAndGet("front-||", "||key", {{"key", ""}}, "key", {true, ""});
+    SetCheckAndGet("back-||", "key||", {{"key", ""}}, "key", {true, ""});
+
+    // Two keys: "key1|key2"
+    SetCheckAndGet("two keys", "key1|key2", {{"key1", ""}, {"key2", ""}}, "key1", {true, ""});
+    CheckGet("two keys", "key2", {true, ""});
+
+    // Extra/double delimiters| "||key1|key2", "|key1|key2", "key1||key2", "key1|key2|",
+    // "key1|key2||"
+    SetCheckAndGet("||two keys", "||key1|key2", {{"key1", ""}, {"key2", ""}}, "key1", {true, ""});
+    CheckGet("||two keys", "key2", {true, ""});
+    SetCheckAndGet("two keys||", "key1|key2||", {{"key1", ""}, {"key2", ""}}, "key1", {true, ""});
+    CheckGet("two keys||", "key2", {true, ""});
+
+    // Key=value: "key=value"
+    SetCheckAndGet("key-val", "key=value", {{"key", "value"}}, "key", {true, "value"});
+
+    // Mixed key-only, key=value| "key1|key2=|key3|key4=value"
+    SetCheckAndGet("mixed",
+                   "key1|key2=value|key3|key4=value",
+                   {{"key1", ""}, {"key2", "value"}, {"key3", ""}, {"key4", "value"}},
+                   "key1",
+                   {true, ""});
+    CheckGet("mixed", "key2", {true, "value"});
+    CheckGet("mixed", "key3", {true, ""});
+    CheckGet("mixed", "key4", {true, "value"});
+
+    // Empty/missing value| "key="
+    SetCheckAndGet("key=", "key=", {{"key", ""}}, "key", {true, ""});
+
+    // Extra `=`| "key==value"
+    SetCheckAndGet("key==", "key==", {{"key", "="}}, "key", {true, "="});
+
+    // Finish last line of verbose output
+    std::cout << std::endl;
+}
+
+/**
+ * \ingroup environ-var-tests
+ *
+ * Environment variable handling test suite.
+ */
+class EnvironmentVariableTestSuite : public TestSuite
+{
+  public:
+    EnvironmentVariableTestSuite();
+};
+
+EnvironmentVariableTestSuite::EnvironmentVariableTestSuite()
+    : TestSuite("environment-variables")
+{
+    AddTestCase(new EnvVarTestCase);
+}
+
+/**
+ * \ingroup environ-var-tests
+ * Static variable for test initialization.
+ */
+static EnvironmentVariableTestSuite g_EnvironmentVariableTestSuite;
+
+} // namespace tests
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/int64x64-test-suite.cc ns-3.38/src/core/test/int64x64-test-suite.cc
--- ns-3.37/src/core/test/int64x64-test-suite.cc	2022-11-01 17:37:24.475395000 -0700
+++ ns-3.38/src/core/test/int64x64-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
@@ -212,7 +212,7 @@
      * Check the int64x64 value for correctness.
      * \param value The int64x64_t value.
      * \param expectInt The expected integer value.
-     * \param expectRnd TThe expected rounding value.
+     * \param expectRnd The expected rounding value.
      */
     void Check(const int64x64_t value, const int64_t expectInt, const int64_t expectRnd);
 };
@@ -866,7 +866,7 @@
      * Check the int64x64 for correctness.
      * \param result The actual value.
      * \param expect The expected value.
-     * \param msg The error mesage to print.
+     * \param msg The error message to print.
      */
     void Check(const bool result, const bool expect, const std::string& msg);
 };
@@ -986,7 +986,7 @@
      * \param factor The factor used to invert the number.
      * \param result The value.
      * \param expect The expected value.
-     * \param msg The error mesage to print.
+     * \param msg The error message to print.
      * \param tolerance The allowed tolerance.
      */
     void CheckCase(const uint64_t factor,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/length-test-suite.cc ns-3.38/src/core/test/length-test-suite.cc
--- ns-3.37/src/core/test/length-test-suite.cc	2022-11-01 17:37:24.475395000 -0700
+++ ns-3.38/src/core/test/length-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
@@ -631,17 +631,19 @@
 
     double inputValue = 10;
 
-    std::map<Unit, Builder> TESTDATA{{Unit::Nanometer, NanoMeters},
-                                     {Unit::Micrometer, MicroMeters},
-                                     {Unit::Millimeter, MilliMeters},
-                                     {Unit::Centimeter, CentiMeters},
-                                     {Unit::Meter, Meters},
-                                     {Unit::Kilometer, KiloMeters},
-                                     {Unit::NauticalMile, NauticalMiles},
-                                     {Unit::Inch, Inches},
-                                     {Unit::Foot, Feet},
-                                     {Unit::Yard, Yards},
-                                     {Unit::Mile, Miles}};
+    std::map<Unit, Builder> TESTDATA{
+        {Unit::Nanometer, NanoMeters},
+        {Unit::Micrometer, MicroMeters},
+        {Unit::Millimeter, MilliMeters},
+        {Unit::Centimeter, CentiMeters},
+        {Unit::Meter, Meters},
+        {Unit::Kilometer, KiloMeters},
+        {Unit::NauticalMile, NauticalMiles},
+        {Unit::Inch, Inches},
+        {Unit::Foot, Feet},
+        {Unit::Yard, Yards},
+        {Unit::Mile, Miles},
+    };
 
     for (auto& entry : TESTDATA)
     {
@@ -670,10 +672,12 @@
 {
     using TestInput = std::pair<double, std::string>;
     using TestArgs = std::pair<double, double>;
-    std::map<TestInput, TestArgs> tests{{{5, "m"}, {5, 0}},
-                                        {{5, " m"}, {5, 0}},
-                                        {{5, "kilometer"}, {5e3, 0}},
-                                        {{5, " kilometer"}, {5e3, 0}}};
+    std::map<TestInput, TestArgs> tests{
+        {{5, "m"}, {5, 0}},
+        {{5, " m"}, {5, 0}},
+        {{5, "kilometer"}, {5e3, 0}},
+        {{5, " kilometer"}, {5e3, 0}},
+    };
 
     for (auto& entry : tests)
     {
